<?php

namespace Lc\ShopBundle\Model;

use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;
use Lc\ShopBundle\Model\AbstractEntity;

/**
 * @ORM\MappedSuperclass
 */
abstract class AbstractDocumentEntity extends AbstractEntity
{
        /**
         * @ORM\Column(type="string", length=255)
         */
        protected $title;

        /**
         * @ORM\Column(type="string", length=255)
         * @Gedmo\Slug(fields={"title"})
         */
        protected $slug;

        /**
         * @ORM\Column(type="text", nullable=true)
         */
        protected $description;

        /**
         * @ORM\Column(type="string", length=255, nullable=true)
         */
        protected $image;

        /**
         * @ORM\Column(type="float")
         */
        protected $status;

        /**
         * @ORM\Column(type="integer")
         * @Gedmo\SortablePosition()
         */
        protected $position;


        public function getTitle(): ?string
        {
                return $this->title;
        }

        public function setTitle(string $title): self
        {
                $this->title = $title;

                return $this;
        }

        public function getSlug(): ?string
        {
                return $this->slug;
        }

        public function setSlug(string $slug): self
        {
                $this->slug = $slug;

                return $this;
        }

        public function getDescription(): ?string
        {
                return $this->description;
        }

        public function setDescription(?string $description): self
        {
                $this->description = $description;

                return $this;
        }

        public function getImage(): ?string
        {
                return $this->image;
        }

        public function setImage(?string $image): self
        {
                $this->image = $image;

                return $this;
        }

        public function getStatus(): ?float
        {
                return $this->status;
        }

        public function setStatus(float $status): self
        {
                $this->status = $status;

                return $this;
        }

        public function getPosition(): ?int
        {
                return $this->position;
        }

        public function setPosition(int $position): self
        {
                $this->position = $position;

                return $this;
        }
}
