<?php

namespace Lc\ShopBundle\Model;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\MappedSuperclass()
 */
abstract class MerchantConfig
{
        /**
         * @ORM\ManyToOne(targetEntity="Lc\ShopBundle\Context\MerchantInterface", inversedBy="merchantConfigs")
         * @ORM\JoinColumn(nullable=false)
         */
        protected $merchant;

        /**
         * @ORM\Column(type="string", length=63)
         */
        protected $name;

        /**
         * @ORM\Column(type="text")
         */
        protected $value;


        public function getMerchant(): ?Merchant
        {
                return $this->merchant;
        }

        public function setMerchant(?Merchant $merchant): self
        {
                $this->merchant = $merchant;

                return $this;
        }

        public function getName(): ?string
        {
                return $this->name;
        }

        public function setName(string $name): self
        {
                $this->name = $name;

                return $this;
        }

        public function getValue(): ?string
        {
                return $this->value;
        }

        public function setValue(string $value): self
        {
                $this->value = $value;

                return $this;
        }
}
